/*
 * Archive plugin script
 * @version @package_version@
 */

rcube_webmail.prototype.toggle_archive = function() {
  var uid = this.message_list.get_single_selection();
  if (uid) {
    var msg = this.env.messages[uid];
    var mbox = (msg && msg.flags && msg.flags.mbox) ?  msg.flags.mbox : this.env.mailbox;
    if (mbox != this.env.drafts_mailbox && 
        mbox.indexOf('Autres utilisateurs') !== 0 && mbox.indexOf('Other Users') !== 0 &&
        mbox.indexOf('Shared Folders') !== 0 && mbox.indexOf('Dossiers partag&AOk-s') !== 0) {
      var buttons = this.buttons['plugin.bm_archive'];
      var row = this.message_list.rows[uid];
      if (row.flags && row.flags.archive) {
        for (var i=0; i < buttons.length; i++) { 
          var button = buttons[i];
          button.pas = 'goog-inline-block goog-button goog-button-base goog-button-base-disabled fa fa-archive btn';
          button.act = 'goog-inline-block goog-button goog-button-base fa fa-archive btn';
        }
        this.set_alttext('plugin.bm_archive', 'bm_archive.promote_title');
      } else {
        for (var i=0; i < buttons.length; i++) { 
          var button = buttons[i];
          button.pas = 'goog-inline-block goog-button goog-button-base goog-button-base-disabled fa fa-archive btn';
          button.act = 'goog-inline-block goog-button goog-button-base fa fa-archive btn';
        }
        this.set_alttext('plugin.bm_archive', 'bm_archive.demote_title');
      }
      this.enable_command('plugin.bm_archive', true);
    }
  } else {
    this.enable_command('plugin.bm_archive', false);
  }
};

rcube_webmail.prototype.promote_message = function(uid, imapid) {
  var row = this.message_list.rows[uid];
  if (row) {
    var td = $(row.obj).find('.archive span');
    row.flags.archive = false;
    row.flags.hsm = null;
    delete row.flags.hsm;
    row.flags.imapid = imapid 
    $(td).removeClass('fa fa-archive');
    this.toggle_archive();
  }
};


rcube_webmail.prototype.demote_message = function(uid, imapid, hsm) {
  var row = this.message_list.rows[uid];
  if (row) {
    var td = $(row.obj).find('.archive span');
    row.flags.archive = true;
    row.flags.hsm = hsm;
    row.flags.imapid = imapid 
    $(td).addClass('fa fa-archive');
    this.toggle_archive();
  }
};

function rcmail_archive(prop) {
  var uid = rcmail.message_list.get_single_selection();
  var mailbox = rcmail.env.mailbox;
  mailbox = (mailbox != rcmail.env.drafts_mailbox) ? mailbox: null;
  var row = rcmail.message_list.rows[uid];
  if (uid && row && mailbox) {
    lock = rcmail.set_busy(true, 'loading'); 
    var td = $(row.obj).find('.archive span');
    if (row.flags && row.flags.archive && row.flags.hsm) {
      var imapid = uid;
      if (row.flags.imapid) {
        imapid = row.flags.imapid;
      }
      rcmail.http_post('plugin.bm_archive.promote', '_imapid='+imapid+'&_hsm='+row.flags.hsm+'&_uid='+uid+'&_mbox='+urlencode(mailbox), lock);
    } else {
      var imapid = uid;
      if (row.flags.imapid) {
        imapid = row.flags.imapid;
      }
      rcmail.http_post('plugin.bm_archive.demote', '_imapid='+imapid+'&_uid='+uid+'&_mbox='+urlencode(mailbox), lock);
    }
  }
}

// callback for app-onload event
if (window.rcmail) {
  rcmail.addEventListener('init', function(evt) {
    
    // register command (directly enable in message view mode)
    rcmail.register_command('plugin.bm_archive', rcmail_archive); 
    // add event-listener to message list
    if (rcmail.message_list) {
      rcmail.message_list.addEventListener('select', function(list){
	rcmail.toggle_archive();
      });
    }
    if (window.rcm_contextmenu_register_command) {
      //rcm_contextmenu_register_command('archive', 'rcmail_archive', 'bm_archive.demote_title', 'delete', 'after', false, false);
      //rcm_contextmenu_register_command('archive', 'rcmail_archive', 'bm_archive.promote_title', 'delete', 'after', false, false);
    }

  });
}

